package api

import "github.com/gogf/gf/v2/frame/g"

type UserCreateReq struct {
	g.Meta   `path:"/user/create" method:"post" tags:"用户相关" summary:"创建用户"`
	UserName string `p:"user_name" v:"required" dc:"用户名"`
	Password string `p:"password" v:"required" dc:"用户密码"`
	NickName string `p:"nick_name" dc:"用户昵称"`
}

type UserUpdateReq struct {
	g.Meta   `path:"/user/update" method:"post" tags:"用户相关" summary:"修改用户"`
	UserId   int    `p:"user_id" v:"required" dc:"用户id"`
	UserName string `p:"user_name" dc:"用户名"`
	Password string `p:"password" dc:"用户密码"`
	NickName string `p:"nick_name" dc:"用户昵称"`
}

type UserDeleteReq struct {
	g.Meta `path:"/user/delete" method:"post" tags:"用户相关" summary:"删除用户"`
	UserId int `p:"user_id" v:"required" dc:"用户id"`
}

type UserLoginReq struct {
	g.Meta   `path:"/user/login" method:"post" tags:"用户相关" summary:"用户登录"`
	UserName string `p:"user_name" v:"required" dc:"用户名"`
	Password string `p:"password" v:"required" dc:"用户密码"`
}

type UserLogoutReq struct {
	g.Meta `path:"/user/logout" method:"post" tags:"用户相关" summary:"用户登出"`
}

type UserTestReq struct {
	g.Meta `path:"/user/test" method:"get" tags:"用户相关" summary:"测试"`
}
