package controller

import (
	"github.com/gogf/gf/v2/frame/g"
	"github.com/gogf/gf/v2/util/gconv"
	"math"
)

type Controller struct{}

func (p *Controller) getPager(count int, page int, pageSize int) g.Map {
	return g.Map{
		"page":       page,
		"page_size":  pageSize,
		"count":      count,
		"total_page": math.Ceil(float64(count) / float64(pageSize)),
	}
}

func (p *Controller) parseReq(req interface{}) g.Map {
	data := gconv.Map(req)
	for k, v := range data {
		if "" == v {
			delete(data, k)
		}
	}
	return data
}
